/**
	@file	AmbientDispatch.h
	@brief	DLControl 𐧌䂷邽߂̊O AmbientDispatchB
	@note

	IAmbientDispatch & CAmbientDispatch

	DLControl 𐧌䂷邽߂̊O AmbientDispatchB
	ȑO atlhost.h 𒼐ڏĎĂ܂AATL̃o[WAbvɂ
	IAxWinAmbientDispatchEx pӂꂽ̂ł̂悤ȕ@ƂȂĂǂȂ܂B
	͕Wł͐䂳Ȃ DLControl ̃ArGgvpeBƃ\bh
	NXłB

	CX^X쐬 SetHostWindow() ŃzXgEBhẼ|C^
	w肵ĂB̌zXgEBhE IAxWinAmbientDispatchEx NG[
	SetAmbientDispatch() ĂŃCX^X̃|C^ݒ肵܂B
	DLControl ̐ݒE擾 put/get_DLControlFlags ĂяoĂB
 */

#pragma once

#include <atlbase.h>
#include <atlapp.h>
#include <atlcom.h>
#include <mshtmdid.h>



class IAmbientDispatch : public IDispatch {
public:
	virtual HRESULT STDMETHODCALLTYPE	put_DLControlFlags(DWORD dwControlFlags)   = 0;
	virtual HRESULT STDMETHODCALLTYPE	get_DLControlFlags(DWORD *pdwControlFlags) = 0;
};



class CAmbientDispatch : public IAmbientDispatch {
private:	//protected:
	//oϐ
	DWORD					  m_dwDLControlFlags;
	CComPtr<IAxWinHostWindow> m_pHost;


public: //CAmbientDispatch
	CAmbientDispatch()
//+++	: m_dwDLControlFlags(DLCTL_VIDEOS | DLCTL_BGSOUNDS)
		: m_dwDLControlFlags(DLCTL_DLIMAGES | DLCTL_VIDEOS | DLCTL_BGSOUNDS)
	{
	}


	void SetHostWindow(const CComPtr<IAxWinHostWindow> &pHost)
	{
		m_pHost = pHost;
	}


	void RefreshAmbient(DISPID dispid)
	{
		//CAxHostWindowFireAmbientPropertyChangeĂяoA
		//|C^ꂻɂȂ̂ŁAInvokeČĂяoB
		//CAxHostWindow::InvokeΖړIBĂ̂͂B
		CComPtr<IDispatch> pDisp;
		HRESULT 		   hr = m_pHost->QueryInterface(&pDisp);
		if ( FAILED(hr) )
			return;
		VARIANT 		   varResult;
		DISPPARAMS		   params = { 0 };
		hr = pDisp->Invoke(dispid, IID_NULL, 1041 /*JP*/, DISPATCH_PROPERTYPUT, &params, &varResult, NULL, NULL);
	}


public: //IUnknown
	STDMETHOD					(QueryInterface)(REFIID riid, void **ppvObject) { return E_NOINTERFACE; }
	ULONG STDMETHODCALLTYPE 	AddRef()  { return 1; }
	ULONG STDMETHODCALLTYPE 	Release() { return 1; }


public: //IDispatch
	STDMETHOD	(GetTypeInfoCount)(UINT * pctinfo) { return E_NOTIMPL; }
	STDMETHOD	(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo * *pptinfo) { return E_NOTIMPL; }
	STDMETHOD	(GetIDsOfNames)(REFIID riid, LPOLESTR * rgszNames, UINT cNames, LCID lcid, DISPID * rgdispid) { return E_NOTIMPL; }

	STDMETHOD	(Invoke)(
			DISPID			dispidMember,
			REFIID			riid,
			LCID			lcid,
			WORD			wFlags,
			DISPPARAMS *	pdispparams,
			VARIANT *		pvarResult,
			EXCEPINFO * 	/*pexcepinfo*/,
			UINT *			/*puArgErr*/)
	{
		if (!pvarResult) {
			return E_INVALIDARG;
		}

		HRESULT hr = E_NOTIMPL;

		if (dispidMember == DISPID_AMBIENT_DLCONTROL) {
			pvarResult->vt	 = VT_I4;
			pvarResult->lVal = m_dwDLControlFlags;
			hr				 = S_OK;
		}

		return hr;
	}


	STDMETHOD	(put_DLControlFlags)(DWORD dwControlFlags)
	{
		m_dwDLControlFlags = dwControlFlags;
		RefreshAmbient(DISPID_AMBIENT_DLCONTROL);
		return S_OK;
	}


	STDMETHOD	(get_DLControlFlags)(DWORD * pdwControlFlags)
	{
		*pdwControlFlags = m_dwDLControlFlags;
		return S_OK;
	}

};
