/**
 *	@file	FileCriticalSection.h
 *	@brief	t@C̃bN/NeBJZbV̏.
 */
#pragma once


#if _ATL_VER >= 0x700	//+++	 Mutex ɕςĂ݂. ]vȒ邱ƂɂȂ邯ǁAň̎Ԃ͌͂....

class CFileCriticalSection {
	friend class	CLockFileOperation;
	static CMutex*		m_pMutex;

public:
	static void Init()
	{
		m_pMutex	 = new CMutex(NULL, 0, DONUT_NAME _T("_FileCriticalSection") );
		ATLASSERT( m_pMutex != 0 );
	}


	static void Term()
	{
		if (m_pMutex) {
			delete m_pMutex;
			m_pMutex = NULL;
		}
	}
};



_declspec(selectany) CMutex *	CFileCriticalSection::m_pMutex = NULL;



class CLockFileOperation : private CMutexLock {
public:
	CLockFileOperation()
		: CMutexLock( *CFileCriticalSection::m_pMutex )
	{
	}

	~CLockFileOperation() {;}
};


#else
class CFileCriticalSection {
	friend class CLockFileOperation;
	static CRITICAL_SECTION *	m_pcs;

public:
	static void Init()
	{
		m_pcs = new CRITICAL_SECTION;

		if (!m_pcs)
			return;

		::InitializeCriticalSection(m_pcs);
	}


	static void Term()
	{
		if (!m_pcs)
			return;

		::DeleteCriticalSection(m_pcs);
		delete m_pcs;
		m_pcs = NULL;	//+++ deleteNA.
	}
};



_declspec(selectany) CRITICAL_SECTION * 	CFileCriticalSection::m_pcs = NULL;



class CLockFileOperation {
public:
	CLockFileOperation()
	{
		if (CFileCriticalSection::m_pcs)
			::EnterCriticalSection(CFileCriticalSection::m_pcs);
	}

	~CLockFileOperation()
	{
		if (CFileCriticalSection::m_pcs)
			::LeaveCriticalSection(CFileCriticalSection::m_pcs);
	}
};

#endif
